package client

import "git.loafle.net/commons_go/rpc/protocol"

type ClientReadWriteCloseHandler interface {
	Connect(clientCTX ClientContext) (interface{}, error)
	NewDecoder(clientCTX ClientContext, codec protocol.ClientCodec, conn interface{}) (interface{}, error)
	ReadResponse(clientCTX ClientContext, codec protocol.ClientCodec, decoder interface{}) (protocol.ClientResponseCodec, error)
	WriteRequest(clientCTX ClientContext, codec protocol.ClientCodec, conn interface{}, method string, params []interface{}, id interface{}) error
	Disconnect(clientCTX ClientContext, conn interface{})

	Validate()
}
