package rpc

import (
	"fmt"

	"git.loafle.net/commons_go/logging"
	"git.loafle.net/commons_go/rpc/protocol"
)

type ServletReadWriteCloseHandlers struct {
}

func (srwch *ServletReadWriteCloseHandlers) NewDecoder(servletCTX ServletContext, codec protocol.ServerCodec, conn interface{}) interface{} {
	logging.Logger().Errorf("Servlet RWC Handler: NewDecoder is not implemented")
	return nil
}

func (srwch *ServletReadWriteCloseHandlers) ReadRequest(servletCTX ServletContext, codec protocol.ServerCodec, decoder interface{}) (protocol.ServerRequestCodec, error) {
	return nil, fmt.Errorf("Servlet RWC Handler: ReadRequest is not implemented")
}

func (srwch *ServletReadWriteCloseHandlers) WriteResponse(servletCTX ServletContext, conn interface{}, requestCodec protocol.ServerRequestCodec, result interface{}, err error) error {
	return fmt.Errorf("Servlet RWC Handler: WriteResponse is not implemented")
}

func (srwch *ServletReadWriteCloseHandlers) WriteNotification(servletCTX ServletContext, conn interface{}, codec protocol.ServerCodec, method string, params []interface{}) error {
	return fmt.Errorf("Servlet RWC Handler: WriteNotification is not implemented")
}

func (srwch *ServletReadWriteCloseHandlers) Validate() {

}
